/* BackgroundManager.c generated by valac 0.56.14, the Vala compiler
 * generated from BackgroundManager.vala, do not modify */

/*
 * Copyright (c) 2011-2015 Wingpanel Developers (http://launchpad.net/wingpanel)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "wingpanel-interface.h"
#include <glib.h>
#include <meta/workspace.h>
#include <glib-object.h>
#include <gala.h>
#include <meta/meta-background-group.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <meta/meta-workspace-manager.h>
#include <meta/display.h>
#include <meta/common.h>
#include <meta/window.h>
#include <gdk/gdk.h>
#include <string.h>
#include <cairo-gobject.h>
#include <stdlib.h>

#define WINGPANEL_INTERFACE_BACKGROUND_MANAGER_MINIMIZE_DURATION 200
#define WINGPANEL_INTERFACE_BACKGROUND_MANAGER_SNAP_DURATION 250
#define WINGPANEL_INTERFACE_BACKGROUND_MANAGER_WALLPAPER_TRANSITION_DURATION 150
#define WINGPANEL_INTERFACE_BACKGROUND_MANAGER_WORKSPACE_SWITCH_DURATION 300
#define WINGPANEL_INTERFACE_BACKGROUND_MANAGER_ACUTANCE_THRESHOLD ((gdouble) 8)
#define WINGPANEL_INTERFACE_BACKGROUND_MANAGER_STD_THRESHOLD ((gdouble) 45)
#define WINGPANEL_INTERFACE_BACKGROUND_MANAGER_LUMINANCE_THRESHOLD ((gdouble) 180)

enum  {
	WINGPANEL_INTERFACE_BACKGROUND_MANAGER_0_PROPERTY,
	WINGPANEL_INTERFACE_BACKGROUND_MANAGER_MONITOR_PROPERTY,
	WINGPANEL_INTERFACE_BACKGROUND_MANAGER_PANEL_HEIGHT_PROPERTY,
	WINGPANEL_INTERFACE_BACKGROUND_MANAGER_NUM_PROPERTIES
};
static GParamSpec* wingpanel_interface_background_manager_properties[WINGPANEL_INTERFACE_BACKGROUND_MANAGER_NUM_PROPERTIES];
#define _wingpanel_interface_utils_color_information_free0(var) ((var == NULL) ? NULL : (var = (wingpanel_interface_utils_color_information_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _WingpanelInterfaceBackgroundManagerUpdateBkColorInfoData WingpanelInterfaceBackgroundManagerUpdateBkColorInfoData;
enum  {
	WINGPANEL_INTERFACE_BACKGROUND_MANAGER_STATE_CHANGED_SIGNAL,
	WINGPANEL_INTERFACE_BACKGROUND_MANAGER_NUM_SIGNALS
};
static guint wingpanel_interface_background_manager_signals[WINGPANEL_INTERFACE_BACKGROUND_MANAGER_NUM_SIGNALS] = {0};

struct _WingpanelInterfaceBackgroundManagerPrivate {
	gint _monitor;
	gint _panel_height;
	gulong wallpaper_hook_id;
	MetaWorkspace* current_workspace;
	BackgroundState current_state;
	WingpanelInterfaceUtilsColorInformation* bk_color_info;
};

struct _Block1Data {
	int _ref_count_;
	WingpanelInterfaceBackgroundManager* self;
	GSourceFunc callback;
	gpointer callback_target;
	GDestroyNotify callback_target_destroy_notify;
	gpointer _async_data_;
};

struct _WingpanelInterfaceBackgroundManagerUpdateBkColorInfoData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	WingpanelInterfaceBackgroundManager* self;
	Block1Data* _data1_;
	GdkRectangle monitor_geometry;
	GdkScreen* _tmp0_;
	gint _tmp1_;
	GdkRectangle _tmp2_;
	GalaWindowManager* _tmp3_;
	gint _tmp4_;
	GdkRectangle _tmp5_;
	gint _tmp6_;
};

static gint WingpanelInterfaceBackgroundManager_private_offset;
static gpointer wingpanel_interface_background_manager_parent_class = NULL;

static void wingpanel_interface_background_manager_connect_signals (WingpanelInterfaceBackgroundManager* self);
static void __lambda13_ (WingpanelInterfaceBackgroundManager* self,
                  GObject* obj,
                  GAsyncResult* res);
static void wingpanel_interface_background_manager_update_current_workspace (WingpanelInterfaceBackgroundManager* self);
static void ___lambda13__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void __lambda4_ (WingpanelInterfaceBackgroundManager* self);
static void ___lambda4__meta_workspace_manager_workspace_switched (MetaWorkspaceManager* _sender,
                                                            gint object,
                                                            gint p0,
                                                            MetaMotionDirection p1,
                                                            gpointer self);
static gboolean __lambda8_ (WingpanelInterfaceBackgroundManager* self,
                     GSignalInvocationHint* ihint,
                     GValue* param_values,
                     guint param_values_length1);
static void __lambda12_ (WingpanelInterfaceBackgroundManager* self,
                  GObject* obj,
                  GAsyncResult* res);
static void wingpanel_interface_background_manager_check_for_state_change (WingpanelInterfaceBackgroundManager* self,
                                                                    guint animation_duration);
static void ___lambda12__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static gboolean ___lambda8__gsignal_emission_hook (GSignalInvocationHint* ihint,
                                            guint n_param_values,
                                            GValue* param_values,
                                            gpointer self);
static void wingpanel_interface_background_manager_on_window_added (WingpanelInterfaceBackgroundManager* self,
                                                             MetaWindow* window);
static void _wingpanel_interface_background_manager_on_window_added_meta_workspace_window_added (MetaWorkspace* _sender,
                                                                                          MetaWindow* object,
                                                                                          gpointer self);
static void wingpanel_interface_background_manager_on_window_removed (WingpanelInterfaceBackgroundManager* self,
                                                               MetaWindow* window);
static void _wingpanel_interface_background_manager_on_window_removed_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                                              MetaWindow* object,
                                                                                              gpointer self);
static void wingpanel_interface_background_manager_register_window (WingpanelInterfaceBackgroundManager* self,
                                                             MetaWindow* window);
static void __lambda5_ (WingpanelInterfaceBackgroundManager* self);
static void ___lambda5__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void __lambda6_ (WingpanelInterfaceBackgroundManager* self);
static void ___lambda6__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void __lambda7_ (WingpanelInterfaceBackgroundManager* self);
static void ___lambda7__meta_window_workspace_changed (MetaWindow* _sender,
                                                gpointer self);
static void wingpanel_interface_background_manager_update_bk_color_info_data_free (gpointer _data);
static gboolean wingpanel_interface_background_manager_update_bk_color_info_co (WingpanelInterfaceBackgroundManagerUpdateBkColorInfoData* _data_);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean _wingpanel_interface_background_manager_update_bk_color_info_co_gsource_func (gpointer self);
static gint wingpanel_interface_background_manager_get_monitor (WingpanelInterfaceBackgroundManager* self);
static gint wingpanel_interface_background_manager_get_panel_height (WingpanelInterfaceBackgroundManager* self);
static void __lambda11_ (Block1Data* _data1_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda11__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void g_cclosure_user_marshal_VOID__ENUM_UINT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static void wingpanel_interface_background_manager_finalize (GObject * obj);
static GType wingpanel_interface_background_manager_get_type_once (void);
static void _vala_wingpanel_interface_background_manager_get_property (GObject * object,
                                                                guint property_id,
                                                                GValue * value,
                                                                GParamSpec * pspec);
static void _vala_wingpanel_interface_background_manager_set_property (GObject * object,
                                                                guint property_id,
                                                                const GValue * value,
                                                                GParamSpec * pspec);

static GType
background_state_get_type_once (void)
{
	static const GEnumValue values[] = {{BACKGROUND_STATE_LIGHT, "BACKGROUND_STATE_LIGHT", "light"}, {BACKGROUND_STATE_DARK, "BACKGROUND_STATE_DARK", "dark"}, {BACKGROUND_STATE_MAXIMIZED, "BACKGROUND_STATE_MAXIMIZED", "maximized"}, {BACKGROUND_STATE_TRANSLUCENT_DARK, "BACKGROUND_STATE_TRANSLUCENT_DARK", "translucent-dark"}, {BACKGROUND_STATE_TRANSLUCENT_LIGHT, "BACKGROUND_STATE_TRANSLUCENT_LIGHT", "translucent-light"}, {0, NULL, NULL}};
	GType background_state_type_id;
	background_state_type_id = g_enum_register_static ("BackgroundState", values);
	return background_state_type_id;
}

GType
background_state_get_type (void)
{
	static volatile gsize background_state_type_id__once = 0;
	if (g_once_init_enter (&background_state_type_id__once)) {
		GType background_state_type_id;
		background_state_type_id = background_state_get_type_once ();
		g_once_init_leave (&background_state_type_id__once, background_state_type_id);
	}
	return background_state_type_id__once;
}

static inline gpointer
wingpanel_interface_background_manager_get_instance_private (WingpanelInterfaceBackgroundManager* self)
{
	return G_STRUCT_MEMBER_P (self, WingpanelInterfaceBackgroundManager_private_offset);
}

static void
__lambda13_ (WingpanelInterfaceBackgroundManager* self,
             GObject* obj,
             GAsyncResult* res)
{
#line 54 "../wingpanel-interface/BackgroundManager.vala"
	g_return_if_fail (res != NULL);
#line 55 "../wingpanel-interface/BackgroundManager.vala"
	wingpanel_interface_background_manager_update_bk_color_info_finish (self, res);
#line 56 "../wingpanel-interface/BackgroundManager.vala"
	wingpanel_interface_background_manager_update_current_workspace (self);
#line 227 "BackgroundManager.c"
}

static void
___lambda13__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 54 "../wingpanel-interface/BackgroundManager.vala"
	__lambda13_ ((WingpanelInterfaceBackgroundManager*) self, source_object, res);
#line 54 "../wingpanel-interface/BackgroundManager.vala"
	g_object_unref (self);
#line 239 "BackgroundManager.c"
}

WingpanelInterfaceBackgroundManager*
wingpanel_interface_background_manager_construct (GType object_type,
                                                  gint monitor,
                                                  gint panel_height)
{
	WingpanelInterfaceBackgroundManager * self = NULL;
#line 51 "../wingpanel-interface/BackgroundManager.vala"
	self = (WingpanelInterfaceBackgroundManager*) g_object_new (object_type, "monitor", monitor, "panel-height", panel_height, NULL);
#line 53 "../wingpanel-interface/BackgroundManager.vala"
	wingpanel_interface_background_manager_connect_signals (self);
#line 54 "../wingpanel-interface/BackgroundManager.vala"
	wingpanel_interface_background_manager_update_bk_color_info (self, ___lambda13__gasync_ready_callback, g_object_ref (self));
#line 50 "../wingpanel-interface/BackgroundManager.vala"
	return self;
#line 256 "BackgroundManager.c"
}

WingpanelInterfaceBackgroundManager*
wingpanel_interface_background_manager_new (gint monitor,
                                            gint panel_height)
{
#line 50 "../wingpanel-interface/BackgroundManager.vala"
	return wingpanel_interface_background_manager_construct (WINGPANEL_INTERFACE_TYPE_BACKGROUND_MANAGER, monitor, panel_height);
#line 265 "BackgroundManager.c"
}

static void
__lambda4_ (WingpanelInterfaceBackgroundManager* self)
{
#line 68 "../wingpanel-interface/BackgroundManager.vala"
	wingpanel_interface_background_manager_update_current_workspace (self);
#line 273 "BackgroundManager.c"
}

static void
___lambda4__meta_workspace_manager_workspace_switched (MetaWorkspaceManager* _sender,
                                                       gint object,
                                                       gint p0,
                                                       MetaMotionDirection p1,
                                                       gpointer self)
{
#line 67 "../wingpanel-interface/BackgroundManager.vala"
	__lambda4_ ((WingpanelInterfaceBackgroundManager*) self);
#line 285 "BackgroundManager.c"
}

static void
__lambda12_ (WingpanelInterfaceBackgroundManager* self,
             GObject* obj,
             GAsyncResult* res)
{
#line 74 "../wingpanel-interface/BackgroundManager.vala"
	g_return_if_fail (res != NULL);
#line 75 "../wingpanel-interface/BackgroundManager.vala"
	wingpanel_interface_background_manager_update_bk_color_info_finish (self, res);
#line 76 "../wingpanel-interface/BackgroundManager.vala"
	wingpanel_interface_background_manager_check_for_state_change (self, (guint) WINGPANEL_INTERFACE_BACKGROUND_MANAGER_WALLPAPER_TRANSITION_DURATION);
#line 299 "BackgroundManager.c"
}

static void
___lambda12__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 74 "../wingpanel-interface/BackgroundManager.vala"
	__lambda12_ ((WingpanelInterfaceBackgroundManager*) self, source_object, res);
#line 74 "../wingpanel-interface/BackgroundManager.vala"
	g_object_unref (self);
#line 311 "BackgroundManager.c"
}

static gboolean
__lambda8_ (WingpanelInterfaceBackgroundManager* self,
            GSignalInvocationHint* ihint,
            GValue* param_values,
            guint param_values_length1)
{
	gboolean result;
#line 73 "../wingpanel-interface/BackgroundManager.vala"
	g_return_val_if_fail (ihint != NULL, FALSE);
#line 74 "../wingpanel-interface/BackgroundManager.vala"
	wingpanel_interface_background_manager_update_bk_color_info (self, ___lambda12__gasync_ready_callback, g_object_ref (self));
#line 79 "../wingpanel-interface/BackgroundManager.vala"
	result = TRUE;
#line 79 "../wingpanel-interface/BackgroundManager.vala"
	return result;
#line 329 "BackgroundManager.c"
}

static gboolean
___lambda8__gsignal_emission_hook (GSignalInvocationHint* ihint,
                                   guint n_param_values,
                                   GValue* param_values,
                                   gpointer self)
{
	gboolean result;
	result = __lambda8_ ((WingpanelInterfaceBackgroundManager*) self, ihint, param_values, n_param_values);
#line 73 "../wingpanel-interface/BackgroundManager.vala"
	return result;
#line 342 "BackgroundManager.c"
}

static void
wingpanel_interface_background_manager_connect_signals (WingpanelInterfaceBackgroundManager* self)
{
	MetaWorkspaceManager* manager = NULL;
	MetaDisplay* _tmp0_;
	MetaWorkspaceManager* _tmp1_;
	guint signal_id = 0U;
	GalaWindowManager* _tmp2_;
	MetaBackgroundGroup* _tmp3_;
	MetaBackgroundGroup* _tmp4_;
#line 65 "../wingpanel-interface/BackgroundManager.vala"
	g_return_if_fail (self != NULL);
#line 66 "../wingpanel-interface/BackgroundManager.vala"
	_tmp0_ = wingpanel_interface_main_display;
#line 66 "../wingpanel-interface/BackgroundManager.vala"
	_tmp1_ = meta_display_get_workspace_manager (_tmp0_);
#line 66 "../wingpanel-interface/BackgroundManager.vala"
	manager = _tmp1_;
#line 67 "../wingpanel-interface/BackgroundManager.vala"
	g_signal_connect_object (manager, "workspace-switched", (GCallback) ___lambda4__meta_workspace_manager_workspace_switched, self, 0);
#line 71 "../wingpanel-interface/BackgroundManager.vala"
	_tmp2_ = wingpanel_interface_main_wm;
#line 71 "../wingpanel-interface/BackgroundManager.vala"
	_tmp3_ = gala_window_manager_get_background_group (_tmp2_);
#line 71 "../wingpanel-interface/BackgroundManager.vala"
	_tmp4_ = _tmp3_;
#line 71 "../wingpanel-interface/BackgroundManager.vala"
	signal_id = g_signal_lookup ("changed", G_TYPE_FROM_INSTANCE ((GObject*) _tmp4_));
#line 73 "../wingpanel-interface/BackgroundManager.vala"
	self->priv->wallpaper_hook_id = g_signal_add_emission_hook (signal_id, (GQuark) 0, ___lambda8__gsignal_emission_hook, g_object_ref (self), g_object_unref);
#line 375 "BackgroundManager.c"
}

static void
_wingpanel_interface_background_manager_on_window_added_meta_workspace_window_added (MetaWorkspace* _sender,
                                                                                     MetaWindow* object,
                                                                                     gpointer self)
{
#line 98 "../wingpanel-interface/BackgroundManager.vala"
	wingpanel_interface_background_manager_on_window_added ((WingpanelInterfaceBackgroundManager*) self, object);
#line 385 "BackgroundManager.c"
}

static void
_wingpanel_interface_background_manager_on_window_removed_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                                         MetaWindow* object,
                                                                                         gpointer self)
{
#line 99 "../wingpanel-interface/BackgroundManager.vala"
	wingpanel_interface_background_manager_on_window_removed ((WingpanelInterfaceBackgroundManager*) self, object);
#line 395 "BackgroundManager.c"
}

static void
wingpanel_interface_background_manager_update_current_workspace (WingpanelInterfaceBackgroundManager* self)
{
	MetaWorkspaceManager* manager = NULL;
	MetaDisplay* _tmp0_;
	MetaWorkspaceManager* _tmp1_;
	MetaWorkspace* workspace = NULL;
	MetaWorkspaceManager* _tmp2_;
	MetaWorkspace* _tmp3_;
	MetaWorkspace* _tmp4_;
	MetaWorkspace* _tmp5_;
	MetaWorkspace* _tmp10_;
	MetaWorkspace* _tmp11_;
	GList* _tmp12_;
	MetaWorkspace* _tmp15_;
	MetaWorkspace* _tmp16_;
#line 87 "../wingpanel-interface/BackgroundManager.vala"
	g_return_if_fail (self != NULL);
#line 88 "../wingpanel-interface/BackgroundManager.vala"
	_tmp0_ = wingpanel_interface_main_display;
#line 88 "../wingpanel-interface/BackgroundManager.vala"
	_tmp1_ = meta_display_get_workspace_manager (_tmp0_);
#line 88 "../wingpanel-interface/BackgroundManager.vala"
	manager = _tmp1_;
#line 89 "../wingpanel-interface/BackgroundManager.vala"
	_tmp2_ = manager;
#line 89 "../wingpanel-interface/BackgroundManager.vala"
	_tmp3_ = meta_workspace_manager_get_active_workspace (_tmp2_);
#line 89 "../wingpanel-interface/BackgroundManager.vala"
	workspace = _tmp3_;
#line 91 "../wingpanel-interface/BackgroundManager.vala"
	_tmp4_ = workspace;
#line 91 "../wingpanel-interface/BackgroundManager.vala"
	if (_tmp4_ == NULL) {
#line 92 "../wingpanel-interface/BackgroundManager.vala"
		g_warning ("BackgroundManager.vala:92: Cannot get active workspace");
#line 94 "../wingpanel-interface/BackgroundManager.vala"
		return;
#line 436 "BackgroundManager.c"
	}
#line 97 "../wingpanel-interface/BackgroundManager.vala"
	_tmp5_ = self->priv->current_workspace;
#line 97 "../wingpanel-interface/BackgroundManager.vala"
	if (_tmp5_ != NULL) {
#line 442 "BackgroundManager.c"
		MetaWorkspace* _tmp6_;
		guint _tmp7_;
		MetaWorkspace* _tmp8_;
		guint _tmp9_;
#line 98 "../wingpanel-interface/BackgroundManager.vala"
		_tmp6_ = self->priv->current_workspace;
#line 98 "../wingpanel-interface/BackgroundManager.vala"
		g_signal_parse_name ("window-added", meta_workspace_get_type (), &_tmp7_, NULL, FALSE);
#line 98 "../wingpanel-interface/BackgroundManager.vala"
		g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _wingpanel_interface_background_manager_on_window_added_meta_workspace_window_added, self);
#line 99 "../wingpanel-interface/BackgroundManager.vala"
		_tmp8_ = self->priv->current_workspace;
#line 99 "../wingpanel-interface/BackgroundManager.vala"
		g_signal_parse_name ("window-removed", meta_workspace_get_type (), &_tmp9_, NULL, FALSE);
#line 99 "../wingpanel-interface/BackgroundManager.vala"
		g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _wingpanel_interface_background_manager_on_window_removed_meta_workspace_window_removed, self);
#line 459 "BackgroundManager.c"
	}
#line 102 "../wingpanel-interface/BackgroundManager.vala"
	_tmp10_ = workspace;
#line 102 "../wingpanel-interface/BackgroundManager.vala"
	self->priv->current_workspace = _tmp10_;
#line 104 "../wingpanel-interface/BackgroundManager.vala"
	_tmp11_ = self->priv->current_workspace;
#line 104 "../wingpanel-interface/BackgroundManager.vala"
	_tmp12_ = meta_workspace_list_windows (_tmp11_);
#line 469 "BackgroundManager.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 104 "../wingpanel-interface/BackgroundManager.vala"
		window_collection = _tmp12_;
#line 104 "../wingpanel-interface/BackgroundManager.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 477 "BackgroundManager.c"
			MetaWindow* window = NULL;
#line 104 "../wingpanel-interface/BackgroundManager.vala"
			window = (MetaWindow*) window_it->data;
#line 481 "BackgroundManager.c"
			{
				MetaWindow* _tmp13_;
#line 105 "../wingpanel-interface/BackgroundManager.vala"
				_tmp13_ = window;
#line 105 "../wingpanel-interface/BackgroundManager.vala"
				if (meta_window_is_on_primary_monitor (_tmp13_)) {
#line 488 "BackgroundManager.c"
					MetaWindow* _tmp14_;
#line 106 "../wingpanel-interface/BackgroundManager.vala"
					_tmp14_ = window;
#line 106 "../wingpanel-interface/BackgroundManager.vala"
					wingpanel_interface_background_manager_register_window (self, _tmp14_);
#line 494 "BackgroundManager.c"
				}
			}
		}
#line 104 "../wingpanel-interface/BackgroundManager.vala"
		(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
#line 500 "BackgroundManager.c"
	}
#line 110 "../wingpanel-interface/BackgroundManager.vala"
	_tmp15_ = self->priv->current_workspace;
#line 110 "../wingpanel-interface/BackgroundManager.vala"
	g_signal_connect_object (_tmp15_, "window-added", (GCallback) _wingpanel_interface_background_manager_on_window_added_meta_workspace_window_added, self, 0);
#line 111 "../wingpanel-interface/BackgroundManager.vala"
	_tmp16_ = self->priv->current_workspace;
#line 111 "../wingpanel-interface/BackgroundManager.vala"
	g_signal_connect_object (_tmp16_, "window-removed", (GCallback) _wingpanel_interface_background_manager_on_window_removed_meta_workspace_window_removed, self, 0);
#line 113 "../wingpanel-interface/BackgroundManager.vala"
	wingpanel_interface_background_manager_check_for_state_change (self, (guint) WINGPANEL_INTERFACE_BACKGROUND_MANAGER_WORKSPACE_SWITCH_DURATION);
#line 512 "BackgroundManager.c"
}

static void
__lambda5_ (WingpanelInterfaceBackgroundManager* self)
{
#line 118 "../wingpanel-interface/BackgroundManager.vala"
	wingpanel_interface_background_manager_check_for_state_change (self, (guint) WINGPANEL_INTERFACE_BACKGROUND_MANAGER_SNAP_DURATION);
#line 520 "BackgroundManager.c"
}

static void
___lambda5__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 117 "../wingpanel-interface/BackgroundManager.vala"
	__lambda5_ ((WingpanelInterfaceBackgroundManager*) self);
#line 530 "BackgroundManager.c"
}

static void
__lambda6_ (WingpanelInterfaceBackgroundManager* self)
{
#line 122 "../wingpanel-interface/BackgroundManager.vala"
	wingpanel_interface_background_manager_check_for_state_change (self, (guint) WINGPANEL_INTERFACE_BACKGROUND_MANAGER_MINIMIZE_DURATION);
#line 538 "BackgroundManager.c"
}

static void
___lambda6__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 121 "../wingpanel-interface/BackgroundManager.vala"
	__lambda6_ ((WingpanelInterfaceBackgroundManager*) self);
#line 548 "BackgroundManager.c"
}

static void
__lambda7_ (WingpanelInterfaceBackgroundManager* self)
{
#line 126 "../wingpanel-interface/BackgroundManager.vala"
	wingpanel_interface_background_manager_check_for_state_change (self, (guint) WINGPANEL_INTERFACE_BACKGROUND_MANAGER_WORKSPACE_SWITCH_DURATION);
#line 556 "BackgroundManager.c"
}

static void
___lambda7__meta_window_workspace_changed (MetaWindow* _sender,
                                           gpointer self)
{
#line 125 "../wingpanel-interface/BackgroundManager.vala"
	__lambda7_ ((WingpanelInterfaceBackgroundManager*) self);
#line 565 "BackgroundManager.c"
}

static void
wingpanel_interface_background_manager_register_window (WingpanelInterfaceBackgroundManager* self,
                                                        MetaWindow* window)
{
#line 116 "../wingpanel-interface/BackgroundManager.vala"
	g_return_if_fail (self != NULL);
#line 116 "../wingpanel-interface/BackgroundManager.vala"
	g_return_if_fail (window != NULL);
#line 117 "../wingpanel-interface/BackgroundManager.vala"
	g_signal_connect_object ((GObject*) window, "notify::maximized-vertically", (GCallback) ___lambda5__g_object_notify, self, 0);
#line 121 "../wingpanel-interface/BackgroundManager.vala"
	g_signal_connect_object ((GObject*) window, "notify::minimized", (GCallback) ___lambda6__g_object_notify, self, 0);
#line 125 "../wingpanel-interface/BackgroundManager.vala"
	g_signal_connect_object (window, "workspace-changed", (GCallback) ___lambda7__meta_window_workspace_changed, self, 0);
#line 582 "BackgroundManager.c"
}

static void
wingpanel_interface_background_manager_on_window_added (WingpanelInterfaceBackgroundManager* self,
                                                        MetaWindow* window)
{
#line 130 "../wingpanel-interface/BackgroundManager.vala"
	g_return_if_fail (self != NULL);
#line 130 "../wingpanel-interface/BackgroundManager.vala"
	g_return_if_fail (window != NULL);
#line 131 "../wingpanel-interface/BackgroundManager.vala"
	wingpanel_interface_background_manager_register_window (self, window);
#line 133 "../wingpanel-interface/BackgroundManager.vala"
	wingpanel_interface_background_manager_check_for_state_change (self, (guint) WINGPANEL_INTERFACE_BACKGROUND_MANAGER_SNAP_DURATION);
#line 597 "BackgroundManager.c"
}

static void
wingpanel_interface_background_manager_on_window_removed (WingpanelInterfaceBackgroundManager* self,
                                                          MetaWindow* window)
{
#line 136 "../wingpanel-interface/BackgroundManager.vala"
	g_return_if_fail (self != NULL);
#line 136 "../wingpanel-interface/BackgroundManager.vala"
	g_return_if_fail (window != NULL);
#line 137 "../wingpanel-interface/BackgroundManager.vala"
	wingpanel_interface_background_manager_check_for_state_change (self, (guint) WINGPANEL_INTERFACE_BACKGROUND_MANAGER_SNAP_DURATION);
#line 610 "BackgroundManager.c"
}

static void
wingpanel_interface_background_manager_update_bk_color_info_data_free (gpointer _data)
{
	WingpanelInterfaceBackgroundManagerUpdateBkColorInfoData* _data_;
	_data_ = _data;
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	_g_object_unref0 (_data_->self);
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	g_slice_free (WingpanelInterfaceBackgroundManagerUpdateBkColorInfoData, _data_);
#line 622 "BackgroundManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 630 "BackgroundManager.c"
}

void
wingpanel_interface_background_manager_update_bk_color_info (WingpanelInterfaceBackgroundManager* self,
                                                             GAsyncReadyCallback _callback_,
                                                             gpointer _user_data_)
{
	WingpanelInterfaceBackgroundManagerUpdateBkColorInfoData* _data_;
	WingpanelInterfaceBackgroundManager* _tmp0_;
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	g_return_if_fail (self != NULL);
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	_data_ = g_slice_new0 (WingpanelInterfaceBackgroundManagerUpdateBkColorInfoData);
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, wingpanel_interface_background_manager_update_bk_color_info_data_free);
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	_data_->self = _tmp0_;
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	wingpanel_interface_background_manager_update_bk_color_info_co (_data_);
#line 654 "BackgroundManager.c"
}

void
wingpanel_interface_background_manager_update_bk_color_info_finish (WingpanelInterfaceBackgroundManager* self,
                                                                    GAsyncResult* _res_)
{
	WingpanelInterfaceBackgroundManagerUpdateBkColorInfoData* _data_;
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 664 "BackgroundManager.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 140 "../wingpanel-interface/BackgroundManager.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 140 "../wingpanel-interface/BackgroundManager.vala"
	return _data1_;
#line 674 "BackgroundManager.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 140 "../wingpanel-interface/BackgroundManager.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 684 "BackgroundManager.c"
		WingpanelInterfaceBackgroundManager* self;
#line 140 "../wingpanel-interface/BackgroundManager.vala"
		self = _data1_->self;
#line 140 "../wingpanel-interface/BackgroundManager.vala"
		(_data1_->callback_target_destroy_notify == NULL) ? NULL : (_data1_->callback_target_destroy_notify (_data1_->callback_target), NULL);
#line 140 "../wingpanel-interface/BackgroundManager.vala"
		_data1_->callback = NULL;
#line 140 "../wingpanel-interface/BackgroundManager.vala"
		_data1_->callback_target = NULL;
#line 140 "../wingpanel-interface/BackgroundManager.vala"
		_data1_->callback_target_destroy_notify = NULL;
#line 140 "../wingpanel-interface/BackgroundManager.vala"
		_g_object_unref0 (self);
#line 140 "../wingpanel-interface/BackgroundManager.vala"
		g_slice_free (Block1Data, _data1_);
#line 700 "BackgroundManager.c"
	}
}

static gboolean
_wingpanel_interface_background_manager_update_bk_color_info_co_gsource_func (gpointer self)
{
	gboolean result;
	result = wingpanel_interface_background_manager_update_bk_color_info_co (self);
#line 141 "../wingpanel-interface/BackgroundManager.vala"
	return result;
#line 711 "BackgroundManager.c"
}

static gpointer
_wingpanel_interface_utils_color_information_dup0 (gpointer self)
{
#line 148 "../wingpanel-interface/BackgroundManager.vala"
	return self ? wingpanel_interface_utils_color_information_dup (self) : NULL;
#line 719 "BackgroundManager.c"
}

static void
__lambda11_ (Block1Data* _data1_,
             GObject* obj,
             GAsyncResult* res)
{
	WingpanelInterfaceBackgroundManager* self;
	GError* _inner_error0_ = NULL;
#line 146 "../wingpanel-interface/BackgroundManager.vala"
	self = _data1_->self;
#line 146 "../wingpanel-interface/BackgroundManager.vala"
	g_return_if_fail (res != NULL);
#line 733 "BackgroundManager.c"
	{
		WingpanelInterfaceUtilsColorInformation _tmp0_ = {0};
		WingpanelInterfaceUtilsColorInformation _tmp1_ = {0};
		WingpanelInterfaceUtilsColorInformation* _tmp2_;
#line 148 "../wingpanel-interface/BackgroundManager.vala"
		wingpanel_interface_utils_get_background_color_information_finish (res, &_tmp1_, &_inner_error0_);
#line 148 "../wingpanel-interface/BackgroundManager.vala"
		_tmp0_ = _tmp1_;
#line 148 "../wingpanel-interface/BackgroundManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 744 "BackgroundManager.c"
			goto __catch0_g_error;
		}
#line 148 "../wingpanel-interface/BackgroundManager.vala"
		_tmp2_ = _wingpanel_interface_utils_color_information_dup0 (&_tmp0_);
#line 148 "../wingpanel-interface/BackgroundManager.vala"
		_wingpanel_interface_utils_color_information_free0 (self->priv->bk_color_info);
#line 148 "../wingpanel-interface/BackgroundManager.vala"
		self->priv->bk_color_info = _tmp2_;
#line 753 "BackgroundManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 147 "../wingpanel-interface/BackgroundManager.vala"
		e = _inner_error0_;
#line 147 "../wingpanel-interface/BackgroundManager.vala"
		_inner_error0_ = NULL;
#line 150 "../wingpanel-interface/BackgroundManager.vala"
		_tmp3_ = e;
#line 150 "../wingpanel-interface/BackgroundManager.vala"
		_tmp4_ = _tmp3_->message;
#line 150 "../wingpanel-interface/BackgroundManager.vala"
		g_warning ("BackgroundManager.vala:150: %s", _tmp4_);
#line 147 "../wingpanel-interface/BackgroundManager.vala"
		_g_error_free0 (e);
#line 773 "BackgroundManager.c"
	}
	__finally0:
	{
		GError* _inner_error1_ = NULL;
#line 152 "../wingpanel-interface/BackgroundManager.vala"
		_data1_->callback (_data1_->callback_target);
#line 780 "BackgroundManager.c"
	}
#line 147 "../wingpanel-interface/BackgroundManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 147 "../wingpanel-interface/BackgroundManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 147 "../wingpanel-interface/BackgroundManager.vala"
		g_clear_error (&_inner_error0_);
#line 147 "../wingpanel-interface/BackgroundManager.vala"
		return;
#line 790 "BackgroundManager.c"
	}
}

static void
___lambda11__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 146 "../wingpanel-interface/BackgroundManager.vala"
	__lambda11_ (self, source_object, res);
#line 146 "../wingpanel-interface/BackgroundManager.vala"
	block1_data_unref (self);
#line 803 "BackgroundManager.c"
}

static gboolean
wingpanel_interface_background_manager_update_bk_color_info_co (WingpanelInterfaceBackgroundManagerUpdateBkColorInfoData* _data_)
{
#line 140 "../wingpanel-interface/BackgroundManager.vala"
	switch (_data_->_state_) {
#line 140 "../wingpanel-interface/BackgroundManager.vala"
		case 0:
#line 813 "BackgroundManager.c"
		goto _state_0;
#line 140 "../wingpanel-interface/BackgroundManager.vala"
		case 1:
#line 817 "BackgroundManager.c"
		goto _state_1;
		default:
#line 140 "../wingpanel-interface/BackgroundManager.vala"
		g_assert_not_reached ();
#line 822 "BackgroundManager.c"
	}
	_state_0:
#line 140 "../wingpanel-interface/BackgroundManager.vala"
	_data_->_data1_ = g_slice_new0 (Block1Data);
#line 140 "../wingpanel-interface/BackgroundManager.vala"
	_data_->_data1_->_ref_count_ = 1;
#line 140 "../wingpanel-interface/BackgroundManager.vala"
	_data_->_data1_->self = g_object_ref (_data_->self);
#line 140 "../wingpanel-interface/BackgroundManager.vala"
	_data_->_data1_->_async_data_ = _data_;
#line 141 "../wingpanel-interface/BackgroundManager.vala"
	_data_->_data1_->callback = _wingpanel_interface_background_manager_update_bk_color_info_co_gsource_func;
#line 141 "../wingpanel-interface/BackgroundManager.vala"
	_data_->_data1_->callback_target = _data_;
#line 141 "../wingpanel-interface/BackgroundManager.vala"
	_data_->_data1_->callback_target_destroy_notify = NULL;
#line 144 "../wingpanel-interface/BackgroundManager.vala"
	_data_->_tmp0_ = gdk_screen_get_default ();
#line 144 "../wingpanel-interface/BackgroundManager.vala"
	_data_->_tmp1_ = _data_->self->priv->_monitor;
#line 144 "../wingpanel-interface/BackgroundManager.vala"
	memset (&_data_->_tmp2_, 0, sizeof (GdkRectangle));
#line 144 "../wingpanel-interface/BackgroundManager.vala"
	gdk_screen_get_monitor_geometry (_data_->_tmp0_, _data_->_tmp1_, &_data_->_tmp2_);
#line 144 "../wingpanel-interface/BackgroundManager.vala"
	_data_->monitor_geometry = _data_->_tmp2_;
#line 146 "../wingpanel-interface/BackgroundManager.vala"
	_data_->_tmp3_ = wingpanel_interface_main_wm;
#line 146 "../wingpanel-interface/BackgroundManager.vala"
	_data_->_tmp4_ = _data_->self->priv->_monitor;
#line 146 "../wingpanel-interface/BackgroundManager.vala"
	_data_->_tmp5_ = _data_->monitor_geometry;
#line 146 "../wingpanel-interface/BackgroundManager.vala"
	_data_->_tmp6_ = _data_->self->priv->_panel_height;
#line 146 "../wingpanel-interface/BackgroundManager.vala"
	wingpanel_interface_utils_get_background_color_information (_data_->_tmp3_, _data_->_tmp4_, 0, 0, _data_->_tmp5_.width, _data_->_tmp6_, ___lambda11__gasync_ready_callback, block1_data_ref (_data_->_data1_));
#line 156 "../wingpanel-interface/BackgroundManager.vala"
	_data_->_state_ = 1;
#line 156 "../wingpanel-interface/BackgroundManager.vala"
	return FALSE;
#line 863 "BackgroundManager.c"
	_state_1:
	;
#line 140 "../wingpanel-interface/BackgroundManager.vala"
	block1_data_unref (_data_->_data1_);
#line 140 "../wingpanel-interface/BackgroundManager.vala"
	_data_->_data1_ = NULL;
#line 140 "../wingpanel-interface/BackgroundManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 140 "../wingpanel-interface/BackgroundManager.vala"
	if (_data_->_state_ != 0) {
#line 140 "../wingpanel-interface/BackgroundManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 140 "../wingpanel-interface/BackgroundManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 878 "BackgroundManager.c"
		}
	}
#line 140 "../wingpanel-interface/BackgroundManager.vala"
	g_object_unref (_data_->_async_result);
#line 140 "../wingpanel-interface/BackgroundManager.vala"
	return FALSE;
#line 885 "BackgroundManager.c"
}

/**
     * Check if Wingpanel's background state should change.
     *
     * The state is defined as follows:
     *  - If there's a maximized window, the state should be MAXIMIZED;
     *  - If no information about the background could be gathered, it should be TRANSLUCENT;
     *  - If there's too much contrast or sharpness, it should be TRANSLUCENT;
     *  - If the background is too bright, it should be DARK;
     *  - Else it should be LIGHT.
     */
static void
wingpanel_interface_background_manager_check_for_state_change (WingpanelInterfaceBackgroundManager* self,
                                                               guint animation_duration)
{
	gboolean has_maximized_window = FALSE;
	MetaWorkspace* _tmp0_;
	GList* _tmp1_;
	BackgroundState new_state = 0;
#line 169 "../wingpanel-interface/BackgroundManager.vala"
	g_return_if_fail (self != NULL);
#line 170 "../wingpanel-interface/BackgroundManager.vala"
	has_maximized_window = FALSE;
#line 172 "../wingpanel-interface/BackgroundManager.vala"
	_tmp0_ = self->priv->current_workspace;
#line 172 "../wingpanel-interface/BackgroundManager.vala"
	_tmp1_ = meta_workspace_list_windows (_tmp0_);
#line 914 "BackgroundManager.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 172 "../wingpanel-interface/BackgroundManager.vala"
		window_collection = _tmp1_;
#line 172 "../wingpanel-interface/BackgroundManager.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 922 "BackgroundManager.c"
			MetaWindow* window = NULL;
#line 172 "../wingpanel-interface/BackgroundManager.vala"
			window = (MetaWindow*) window_it->data;
#line 926 "BackgroundManager.c"
			{
				MetaWindow* _tmp2_;
#line 173 "../wingpanel-interface/BackgroundManager.vala"
				_tmp2_ = window;
#line 173 "../wingpanel-interface/BackgroundManager.vala"
				if (meta_window_is_on_primary_monitor (_tmp2_)) {
#line 933 "BackgroundManager.c"
					gboolean _tmp3_ = FALSE;
					MetaWindow* _tmp4_;
					gboolean _tmp5_;
					gboolean _tmp6_;
#line 174 "../wingpanel-interface/BackgroundManager.vala"
					_tmp4_ = window;
#line 174 "../wingpanel-interface/BackgroundManager.vala"
					g_object_get (_tmp4_, "minimized", &_tmp5_, NULL);
#line 174 "../wingpanel-interface/BackgroundManager.vala"
					_tmp6_ = _tmp5_;
#line 174 "../wingpanel-interface/BackgroundManager.vala"
					if (!_tmp6_) {
#line 946 "BackgroundManager.c"
						MetaWindow* _tmp7_;
						gboolean _tmp8_;
						gboolean _tmp9_;
#line 174 "../wingpanel-interface/BackgroundManager.vala"
						_tmp7_ = window;
#line 174 "../wingpanel-interface/BackgroundManager.vala"
						g_object_get (_tmp7_, "maximized-vertically", &_tmp8_, NULL);
#line 174 "../wingpanel-interface/BackgroundManager.vala"
						_tmp9_ = _tmp8_;
#line 174 "../wingpanel-interface/BackgroundManager.vala"
						_tmp3_ = _tmp9_;
#line 958 "BackgroundManager.c"
					} else {
#line 174 "../wingpanel-interface/BackgroundManager.vala"
						_tmp3_ = FALSE;
#line 962 "BackgroundManager.c"
					}
#line 174 "../wingpanel-interface/BackgroundManager.vala"
					if (_tmp3_) {
#line 175 "../wingpanel-interface/BackgroundManager.vala"
						has_maximized_window = TRUE;
#line 176 "../wingpanel-interface/BackgroundManager.vala"
						break;
#line 970 "BackgroundManager.c"
					}
				}
			}
		}
#line 172 "../wingpanel-interface/BackgroundManager.vala"
		(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
#line 977 "BackgroundManager.c"
	}
#line 183 "../wingpanel-interface/BackgroundManager.vala"
	if (has_maximized_window) {
#line 184 "../wingpanel-interface/BackgroundManager.vala"
		new_state = BACKGROUND_STATE_MAXIMIZED;
#line 983 "BackgroundManager.c"
	} else {
		WingpanelInterfaceUtilsColorInformation* _tmp10_;
#line 185 "../wingpanel-interface/BackgroundManager.vala"
		_tmp10_ = self->priv->bk_color_info;
#line 185 "../wingpanel-interface/BackgroundManager.vala"
		if (_tmp10_ == NULL) {
#line 186 "../wingpanel-interface/BackgroundManager.vala"
			new_state = BACKGROUND_STATE_TRANSLUCENT_LIGHT;
#line 992 "BackgroundManager.c"
		} else {
			gdouble luminance_std = 0.0;
			WingpanelInterfaceUtilsColorInformation* _tmp11_;
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_ = FALSE;
			gboolean bg_is_busy = FALSE;
			gboolean bg_is_dark = FALSE;
			WingpanelInterfaceUtilsColorInformation* _tmp18_;
			gboolean bg_is_busy_dark = FALSE;
			WingpanelInterfaceUtilsColorInformation* _tmp19_;
			gboolean _tmp20_ = FALSE;
#line 188 "../wingpanel-interface/BackgroundManager.vala"
			_tmp11_ = self->priv->bk_color_info;
#line 188 "../wingpanel-interface/BackgroundManager.vala"
			luminance_std = sqrt ((*_tmp11_).luminance_variance);
#line 190 "../wingpanel-interface/BackgroundManager.vala"
			if (luminance_std > WINGPANEL_INTERFACE_BACKGROUND_MANAGER_STD_THRESHOLD) {
#line 190 "../wingpanel-interface/BackgroundManager.vala"
				_tmp13_ = TRUE;
#line 1012 "BackgroundManager.c"
			} else {
				gboolean _tmp14_ = FALSE;
				WingpanelInterfaceUtilsColorInformation* _tmp15_;
#line 191 "../wingpanel-interface/BackgroundManager.vala"
				_tmp15_ = self->priv->bk_color_info;
#line 191 "../wingpanel-interface/BackgroundManager.vala"
				if ((*_tmp15_).mean_luminance < WINGPANEL_INTERFACE_BACKGROUND_MANAGER_LUMINANCE_THRESHOLD) {
#line 1020 "BackgroundManager.c"
					WingpanelInterfaceUtilsColorInformation* _tmp16_;
#line 192 "../wingpanel-interface/BackgroundManager.vala"
					_tmp16_ = self->priv->bk_color_info;
#line 192 "../wingpanel-interface/BackgroundManager.vala"
					_tmp14_ = ((*_tmp16_).mean_luminance + (1.645 * luminance_std)) > WINGPANEL_INTERFACE_BACKGROUND_MANAGER_LUMINANCE_THRESHOLD;
#line 1026 "BackgroundManager.c"
				} else {
#line 191 "../wingpanel-interface/BackgroundManager.vala"
					_tmp14_ = FALSE;
#line 1030 "BackgroundManager.c"
				}
#line 191 "../wingpanel-interface/BackgroundManager.vala"
				_tmp13_ = _tmp14_;
#line 1034 "BackgroundManager.c"
			}
#line 190 "../wingpanel-interface/BackgroundManager.vala"
			if (_tmp13_) {
#line 190 "../wingpanel-interface/BackgroundManager.vala"
				_tmp12_ = TRUE;
#line 1040 "BackgroundManager.c"
			} else {
				WingpanelInterfaceUtilsColorInformation* _tmp17_;
#line 193 "../wingpanel-interface/BackgroundManager.vala"
				_tmp17_ = self->priv->bk_color_info;
#line 193 "../wingpanel-interface/BackgroundManager.vala"
				_tmp12_ = (*_tmp17_).mean_acutance > WINGPANEL_INTERFACE_BACKGROUND_MANAGER_ACUTANCE_THRESHOLD;
#line 1047 "BackgroundManager.c"
			}
#line 190 "../wingpanel-interface/BackgroundManager.vala"
			bg_is_busy = _tmp12_;
#line 195 "../wingpanel-interface/BackgroundManager.vala"
			_tmp18_ = self->priv->bk_color_info;
#line 195 "../wingpanel-interface/BackgroundManager.vala"
			bg_is_dark = (*_tmp18_).mean_luminance > WINGPANEL_INTERFACE_BACKGROUND_MANAGER_LUMINANCE_THRESHOLD;
#line 196 "../wingpanel-interface/BackgroundManager.vala"
			_tmp19_ = self->priv->bk_color_info;
#line 196 "../wingpanel-interface/BackgroundManager.vala"
			bg_is_busy_dark = ((*_tmp19_).mean_luminance * 1.25) > WINGPANEL_INTERFACE_BACKGROUND_MANAGER_LUMINANCE_THRESHOLD;
#line 198 "../wingpanel-interface/BackgroundManager.vala"
			if (bg_is_busy) {
#line 198 "../wingpanel-interface/BackgroundManager.vala"
				_tmp20_ = bg_is_busy_dark;
#line 1063 "BackgroundManager.c"
			} else {
#line 198 "../wingpanel-interface/BackgroundManager.vala"
				_tmp20_ = FALSE;
#line 1067 "BackgroundManager.c"
			}
#line 198 "../wingpanel-interface/BackgroundManager.vala"
			if (_tmp20_) {
#line 199 "../wingpanel-interface/BackgroundManager.vala"
				new_state = BACKGROUND_STATE_TRANSLUCENT_DARK;
#line 1073 "BackgroundManager.c"
			} else {
#line 200 "../wingpanel-interface/BackgroundManager.vala"
				if (bg_is_busy) {
#line 201 "../wingpanel-interface/BackgroundManager.vala"
					new_state = BACKGROUND_STATE_TRANSLUCENT_LIGHT;
#line 1079 "BackgroundManager.c"
				} else {
#line 202 "../wingpanel-interface/BackgroundManager.vala"
					if (bg_is_dark) {
#line 203 "../wingpanel-interface/BackgroundManager.vala"
						new_state = BACKGROUND_STATE_DARK;
#line 1085 "BackgroundManager.c"
					} else {
#line 205 "../wingpanel-interface/BackgroundManager.vala"
						new_state = BACKGROUND_STATE_LIGHT;
#line 1089 "BackgroundManager.c"
					}
				}
			}
		}
	}
#line 209 "../wingpanel-interface/BackgroundManager.vala"
	if (new_state != self->priv->current_state) {
#line 210 "../wingpanel-interface/BackgroundManager.vala"
		self->priv->current_state = new_state;
#line 210 "../wingpanel-interface/BackgroundManager.vala"
		g_signal_emit (self, wingpanel_interface_background_manager_signals[WINGPANEL_INTERFACE_BACKGROUND_MANAGER_STATE_CHANGED_SIGNAL], 0, self->priv->current_state, animation_duration);
#line 1101 "BackgroundManager.c"
	}
}

static gint
wingpanel_interface_background_manager_get_monitor (WingpanelInterfaceBackgroundManager* self)
{
	gint result;
#line 39 "../wingpanel-interface/BackgroundManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 39 "../wingpanel-interface/BackgroundManager.vala"
	result = self->priv->_monitor;
#line 39 "../wingpanel-interface/BackgroundManager.vala"
	return result;
#line 1115 "BackgroundManager.c"
}

static void
wingpanel_interface_background_manager_set_monitor (WingpanelInterfaceBackgroundManager* self,
                                                    gint value)
{
	gint old_value;
#line 39 "../wingpanel-interface/BackgroundManager.vala"
	g_return_if_fail (self != NULL);
#line 39 "../wingpanel-interface/BackgroundManager.vala"
	old_value = wingpanel_interface_background_manager_get_monitor (self);
#line 39 "../wingpanel-interface/BackgroundManager.vala"
	if (old_value != value) {
#line 39 "../wingpanel-interface/BackgroundManager.vala"
		self->priv->_monitor = value;
#line 39 "../wingpanel-interface/BackgroundManager.vala"
		g_object_notify_by_pspec ((GObject *) self, wingpanel_interface_background_manager_properties[WINGPANEL_INTERFACE_BACKGROUND_MANAGER_MONITOR_PROPERTY]);
#line 1133 "BackgroundManager.c"
	}
}

static gint
wingpanel_interface_background_manager_get_panel_height (WingpanelInterfaceBackgroundManager* self)
{
	gint result;
#line 40 "../wingpanel-interface/BackgroundManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 40 "../wingpanel-interface/BackgroundManager.vala"
	result = self->priv->_panel_height;
#line 40 "../wingpanel-interface/BackgroundManager.vala"
	return result;
#line 1147 "BackgroundManager.c"
}

static void
wingpanel_interface_background_manager_set_panel_height (WingpanelInterfaceBackgroundManager* self,
                                                         gint value)
{
	gint old_value;
#line 40 "../wingpanel-interface/BackgroundManager.vala"
	g_return_if_fail (self != NULL);
#line 40 "../wingpanel-interface/BackgroundManager.vala"
	old_value = wingpanel_interface_background_manager_get_panel_height (self);
#line 40 "../wingpanel-interface/BackgroundManager.vala"
	if (old_value != value) {
#line 40 "../wingpanel-interface/BackgroundManager.vala"
		self->priv->_panel_height = value;
#line 40 "../wingpanel-interface/BackgroundManager.vala"
		g_object_notify_by_pspec ((GObject *) self, wingpanel_interface_background_manager_properties[WINGPANEL_INTERFACE_BACKGROUND_MANAGER_PANEL_HEIGHT_PROPERTY]);
#line 1165 "BackgroundManager.c"
	}
}

static void
g_cclosure_user_marshal_VOID__ENUM_UINT (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__ENUM_UINT) (gpointer data1, gint arg_1, guint arg_2, gpointer data2);
	register GMarshalFunc_VOID__ENUM_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	g_return_if_fail (n_param_values == 3);
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 28 "../wingpanel-interface/BackgroundManager.vala"
		data1 = closure->data;
#line 28 "../wingpanel-interface/BackgroundManager.vala"
		data2 = param_values->data[0].v_pointer;
#line 1191 "BackgroundManager.c"
	} else {
#line 28 "../wingpanel-interface/BackgroundManager.vala"
		data1 = param_values->data[0].v_pointer;
#line 28 "../wingpanel-interface/BackgroundManager.vala"
		data2 = closure->data;
#line 1197 "BackgroundManager.c"
	}
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	callback = (GMarshalFunc_VOID__ENUM_UINT) (marshal_data ? marshal_data : cc->callback);
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	callback (data1, g_value_get_enum (param_values + 1), g_value_get_uint (param_values + 2), data2);
#line 1203 "BackgroundManager.c"
}

static void
wingpanel_interface_background_manager_class_init (WingpanelInterfaceBackgroundManagerClass * klass,
                                                   gpointer klass_data)
{
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	wingpanel_interface_background_manager_parent_class = g_type_class_peek_parent (klass);
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	g_type_class_adjust_private_offset (klass, &WingpanelInterfaceBackgroundManager_private_offset);
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_wingpanel_interface_background_manager_get_property;
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_wingpanel_interface_background_manager_set_property;
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	G_OBJECT_CLASS (klass)->finalize = wingpanel_interface_background_manager_finalize;
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WINGPANEL_INTERFACE_BACKGROUND_MANAGER_MONITOR_PROPERTY, wingpanel_interface_background_manager_properties[WINGPANEL_INTERFACE_BACKGROUND_MANAGER_MONITOR_PROPERTY] = g_param_spec_int ("monitor", "monitor", "monitor", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WINGPANEL_INTERFACE_BACKGROUND_MANAGER_PANEL_HEIGHT_PROPERTY, wingpanel_interface_background_manager_properties[WINGPANEL_INTERFACE_BACKGROUND_MANAGER_PANEL_HEIGHT_PROPERTY] = g_param_spec_int ("panel-height", "panel-height", "panel-height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	wingpanel_interface_background_manager_signals[WINGPANEL_INTERFACE_BACKGROUND_MANAGER_STATE_CHANGED_SIGNAL] = g_signal_new ("state-changed", WINGPANEL_INTERFACE_TYPE_BACKGROUND_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__ENUM_UINT, G_TYPE_NONE, 2, TYPE_BACKGROUND_STATE, G_TYPE_UINT);
#line 1226 "BackgroundManager.c"
}

static void
wingpanel_interface_background_manager_instance_init (WingpanelInterfaceBackgroundManager * self,
                                                      gpointer klass)
{
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	self->priv = wingpanel_interface_background_manager_get_instance_private (self);
#line 44 "../wingpanel-interface/BackgroundManager.vala"
	self->priv->current_workspace = NULL;
#line 46 "../wingpanel-interface/BackgroundManager.vala"
	self->priv->current_state = BACKGROUND_STATE_LIGHT;
#line 48 "../wingpanel-interface/BackgroundManager.vala"
	self->priv->bk_color_info = NULL;
#line 1241 "BackgroundManager.c"
}

static void
wingpanel_interface_background_manager_finalize (GObject * obj)
{
	WingpanelInterfaceBackgroundManager * self;
	guint signal_id = 0U;
	GalaWindowManager* _tmp0_;
	MetaBackgroundGroup* _tmp1_;
	MetaBackgroundGroup* _tmp2_;
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WINGPANEL_INTERFACE_TYPE_BACKGROUND_MANAGER, WingpanelInterfaceBackgroundManager);
#line 61 "../wingpanel-interface/BackgroundManager.vala"
	_tmp0_ = wingpanel_interface_main_wm;
#line 61 "../wingpanel-interface/BackgroundManager.vala"
	_tmp1_ = gala_window_manager_get_background_group (_tmp0_);
#line 61 "../wingpanel-interface/BackgroundManager.vala"
	_tmp2_ = _tmp1_;
#line 61 "../wingpanel-interface/BackgroundManager.vala"
	signal_id = g_signal_lookup ("changed", G_TYPE_FROM_INSTANCE ((GObject*) _tmp2_));
#line 62 "../wingpanel-interface/BackgroundManager.vala"
	g_signal_remove_emission_hook (signal_id, self->priv->wallpaper_hook_id);
#line 48 "../wingpanel-interface/BackgroundManager.vala"
	_wingpanel_interface_utils_color_information_free0 (self->priv->bk_color_info);
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	G_OBJECT_CLASS (wingpanel_interface_background_manager_parent_class)->finalize (obj);
#line 1268 "BackgroundManager.c"
}

static GType
wingpanel_interface_background_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WingpanelInterfaceBackgroundManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wingpanel_interface_background_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WingpanelInterfaceBackgroundManager), 0, (GInstanceInitFunc) wingpanel_interface_background_manager_instance_init, NULL };
	GType wingpanel_interface_background_manager_type_id;
	wingpanel_interface_background_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "WingpanelInterfaceBackgroundManager", &g_define_type_info, 0);
	WingpanelInterfaceBackgroundManager_private_offset = g_type_add_instance_private (wingpanel_interface_background_manager_type_id, sizeof (WingpanelInterfaceBackgroundManagerPrivate));
	return wingpanel_interface_background_manager_type_id;
}

GType
wingpanel_interface_background_manager_get_type (void)
{
	static volatile gsize wingpanel_interface_background_manager_type_id__once = 0;
	if (g_once_init_enter (&wingpanel_interface_background_manager_type_id__once)) {
		GType wingpanel_interface_background_manager_type_id;
		wingpanel_interface_background_manager_type_id = wingpanel_interface_background_manager_get_type_once ();
		g_once_init_leave (&wingpanel_interface_background_manager_type_id__once, wingpanel_interface_background_manager_type_id);
	}
	return wingpanel_interface_background_manager_type_id__once;
}

static void
_vala_wingpanel_interface_background_manager_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec)
{
	WingpanelInterfaceBackgroundManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WINGPANEL_INTERFACE_TYPE_BACKGROUND_MANAGER, WingpanelInterfaceBackgroundManager);
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	switch (property_id) {
#line 28 "../wingpanel-interface/BackgroundManager.vala"
		case WINGPANEL_INTERFACE_BACKGROUND_MANAGER_MONITOR_PROPERTY:
#line 28 "../wingpanel-interface/BackgroundManager.vala"
		g_value_set_int (value, wingpanel_interface_background_manager_get_monitor (self));
#line 28 "../wingpanel-interface/BackgroundManager.vala"
		break;
#line 28 "../wingpanel-interface/BackgroundManager.vala"
		case WINGPANEL_INTERFACE_BACKGROUND_MANAGER_PANEL_HEIGHT_PROPERTY:
#line 28 "../wingpanel-interface/BackgroundManager.vala"
		g_value_set_int (value, wingpanel_interface_background_manager_get_panel_height (self));
#line 28 "../wingpanel-interface/BackgroundManager.vala"
		break;
#line 1315 "BackgroundManager.c"
		default:
#line 28 "../wingpanel-interface/BackgroundManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../wingpanel-interface/BackgroundManager.vala"
		break;
#line 1321 "BackgroundManager.c"
	}
}

static void
_vala_wingpanel_interface_background_manager_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec)
{
	WingpanelInterfaceBackgroundManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WINGPANEL_INTERFACE_TYPE_BACKGROUND_MANAGER, WingpanelInterfaceBackgroundManager);
#line 28 "../wingpanel-interface/BackgroundManager.vala"
	switch (property_id) {
#line 28 "../wingpanel-interface/BackgroundManager.vala"
		case WINGPANEL_INTERFACE_BACKGROUND_MANAGER_MONITOR_PROPERTY:
#line 28 "../wingpanel-interface/BackgroundManager.vala"
		wingpanel_interface_background_manager_set_monitor (self, g_value_get_int (value));
#line 28 "../wingpanel-interface/BackgroundManager.vala"
		break;
#line 28 "../wingpanel-interface/BackgroundManager.vala"
		case WINGPANEL_INTERFACE_BACKGROUND_MANAGER_PANEL_HEIGHT_PROPERTY:
#line 28 "../wingpanel-interface/BackgroundManager.vala"
		wingpanel_interface_background_manager_set_panel_height (self, g_value_get_int (value));
#line 28 "../wingpanel-interface/BackgroundManager.vala"
		break;
#line 1347 "BackgroundManager.c"
		default:
#line 28 "../wingpanel-interface/BackgroundManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../wingpanel-interface/BackgroundManager.vala"
		break;
#line 1353 "BackgroundManager.c"
	}
}

